#include "spdlog.hpp"
#include "spdlog_qt.hpp"

#include <QCoreApplication>

namespace myx {

namespace log {

void spdlog_qt_message_handler( QtMsgType type, const QMessageLogContext& context, const QString& qMsg )
{
	Q_UNUSED( context )

	if ( !default_logger.logger() )
	{
		return;
	}

	auto message = qMsg.toUtf8();

	switch ( type )
	{
	case QtDebugMsg:
		default_logger.logger()->debug( message.constData() );
		break;
	case QtInfoMsg:
		default_logger.logger()->info( message.constData() );
		break;
	case QtWarningMsg:
		default_logger.logger()->warn( message.constData() );
		break;
	case QtCriticalMsg:
		default_logger.logger()->critical( message.constData() );
		break;
	case QtFatalMsg:
		default_logger.logger()->critical( "FATAL: %s", message.constData() );
		QCoreApplication::exit( 1 );
		break;
	}
}  // messageHandler

} // namespace log

} // namespace myx
